<script setup lang="ts">
import DeleteModal from "./DeleteModal.vue";
import {
  type OwnershipTransferRequestOut,
  OwnershipTypeEnum,
} from "@/client/types.gen.ts";
import { useNameStore } from "@/stores";

const props = defineProps<{
  modalId: string;
  otr?: OwnershipTransferRequestOut;
  backModalId?: string;
  otrType: OwnershipTypeEnum;
}>();

const nameRepository = useNameStore();

const emit = defineEmits<{
  (e: "confirm-delete", otr: OwnershipTransferRequestOut): void;
}>();

function deleteOtr() {
  if (props.otr != undefined) {
    emit("confirm-delete", props.otr);
    window._paq?.push(["trackEvent", "Delete", `${props.otrType} OTR`]);
  }
}
</script>

<template>
  <delete-modal
    :modal-id="props.modalId"
    :back-modal-id="props.backModalId"
    :delete-type="`${otrType} transfer request`"
    :disabled="props.otr == undefined"
    @confirm-delete="deleteOtr"
  >
    <template #body>
      <p>
        Are you sure you want to delete the {{ props.otrType }} transfer request
        for
        <strong v-if="props.otr">{{
          props.otrType === OwnershipTypeEnum.BUCKET
            ? props.otr.target_id
            : nameRepository.getName(props.otr.target_id)
        }}</strong>
        <template v-if="props.otr && props.otr.current_owner_uid">
          from the user
          <strong>{{
            nameRepository.getName(props.otr.current_owner_uid)
          }}</strong></template
        >
        to the user
        <strong v-if="props.otr">{{
          nameRepository.getName(props.otr.new_owner_uid)
        }}</strong
        >?
      </p>
    </template>
  </delete-modal>
</template>

<style scoped></style>
